AchSnd_Defaults = {
-- Default Settings   All settings can be changed in game with
-- the /achsnd command
Guild = "on", -- Enable on guild member achievements
Party = "on", -- Enable on party members achievements
Near = "on",  -- Enable for people near you
--
--Addon Output Settings
MSBT = "on",  -- Output achievement to Mik's Scrolling Battle Text
Popup = "on", -- Grats popup
Sound = "on", -- Enable Sound Output
Timeout = 15, -- Popup timeout between 0 - 60 secs
Random = "on", -- Random messages or default
--
--Addon State
Enable = "on" -- enable/disable the addon 
}

AchSnd_Settings = {}
MDSet=0

local gmsg="{star} Grats {star}" -- Grats Message

AchSnd = CreateFrame("Frame")
AchSnd:RegisterEvent("ADDON_LOADED")
AchSnd:RegisterEvent("CHAT_MSG_ACHIEVEMENT")
AchSnd:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")

local function statcolor(stat)
	if (stat == "on") then
		return "|cFF00FF00[on]"
	elseif (stat == "off") then
		return "|cFFFF0000[off]"
	elseif (stat == 0) then
		return "|cFFFF0000[0] (DISABLED)"
	elseif ((stat >=1) and (stat <= 60)) then
		retstr = "|cFF00FF00[%i] second(s)"
		retstr = retstr:format(stat)
		return retstr
	end
	return stat
end

function randmsg(mode)
	prefix =  {"(`._.[" , "..|..<(+_" , "-==-" , "o.O" , "(-" , "(`[" , "([" , "" , "![" , "*(`(F)(" , "(`[*" , ".)(`[" , "" , "o.O" , ".`)" , " ^v`)" , ",.-~*`*~-.-(_" , "- - --^[" , ".`." , "`..`._." , "(`._)" , "*~-.,.-~*" , "O" , "׺`" , ".`->" , "<))))><.`." , "- ---^]" , ".|.<(+_+)>.|/." , "+*^*+"}
	postfix = {"]._.)" , "_+)>..|.." , "-==-" , "O.o" , "-)" , "]״)" , "])" , "" , "]!" , ")(F))*" , "*])" , "])(` ." , "" , "O.o" , "(`." , "(״`v^ " , "_)-,.-~*`*~-." , "]^-- - -" , ".`." , "`..`._." , " (`._)" , "*~-.,.-~*" , "O" , "׺`" , "<-`." , ".`.><((((>" , "[^--- -" , ".|.<(+_+)>.|/." , "+*^*+"}
	grtz = {"Grats" , "Congratulations" , "Gratz" , "Great Job" , "Awesome" , "Nice One"}
	
	fixnum = math.random(1, #prefix)
	grtznum = math.random(1, #grtz)
	
	message = prefix[fixnum].." "..grtz[grtznum].." "..postfix[fixnum]
	return message
end

AchSnd:SetScript("OnEvent",function(self, event,...)
	if (event == "ADDON_LOADED") then
		if (MDSet == 1) then
			return
		end
		print("/n/nAchievement Sounds loaded/n/n")
		local function addOptionMt(options, defaults)
			setmetatable(options, {__index = defaults})
			for i, v in pairs(options) do
				if type(v) == "table" and not getmetatable(v) then
					addOptionMt(v, defaults[i])
				end
			end
		end
		addOptionMt(AchSnd_Settings, AchSnd_Defaults)
		MDSet = 1
		return self, event, ...
	end
	
	if (AchSnd_Settings.Enable == "off") then
		return
	end
	
	local args = {...}
	color = {255,255,255}
	mode = "DEFAULT"
	msg = args[1]:format(args[5])
	
	if (args[5] == UnitName("player")) then
		return
	end
	
	if (event == "CHAT_MSG_ACHIEVEMENT")then
		if (UnitInParty(args[5])) then
			if (AchSnd_Settings.Party ~="on") then 
				return
			end
			color = {0,255,255}
			mode = "PARTY"
		else
			if (AchSnd_Settings.Near ~="on")then
				return
			end
			color = {255,255,255}
			mode = "SAY"
		end
	end
	
	if (event == "CHAT_MSG_GUILD_ACHIEVEMENT") then
		if (AchSnd_Settings.Guild ~= "on") then
			return
		end
		color = {0,255,0}
		mode = "GUILD"
	end
	
	if (mode == "DEFAULT") then
		return
	end

	if(IsAddOnLoaded("MikScrollingBattleText")) then
		if ((AchSnd_Settings.MSBT == "on") and (not(MikSBT.IsModDisabled() ))) then
			MikSBT.DisplayMessage( msg , MikSBT.DISPLAYTYPE_NOTIFICATION, true, color[1], color[2], color[3])
		end
	end

	if (AchSnd_Settings.Sound == "on") then
		PlaySound("LEVELUPSOUND")
	end
	
	if (AchSnd_Settings.Popup == "on") then
		StaticPopupDialogs["AchSnd"] = {
			text = msg,
			button1 = mode.." Grats",
			button2 = "Cancel",
			OnAccept = function(self)
				if (AchSnd_Settings.Random == "on") then
					SendChatMessage( randmsg(mode) , mode)
				else
					SendChatMessage( gmsg , mode )
				end
			end,
			timeout = AchSnd_Settings.Timeout
			}
			
		StaticPopup_Show("AchSnd")
	end

end) 


SLASH_ACHSND1 = "/achsnd"
SlashCmdList["ACHSND"] = function(msg)
	local cmd,arg = string.split(" ", msg)
	cmd = cmd:lower()
	yel = "|cFFFFFF00"
	wht = "|cFFFFFFFF"
	blu = "|cFF00FFFF"
	red = "|cFFFF0000"
	grn = "|cFF00FF00"
	res = "|r"

	if (cmd == "enable") then
		if ((arg == "1") or (arg == "on")) then
			AchSnd_Settings.Enable = "on"
		elseif ((arg == "0") or (arg == "off")) then
			AchSnd_Settings.Enable = "off"
		end
		print(yel.."Achievement Sounds: Enable is now "..statcolor(AchSnd_Settings.Enable)..res)
		return
	end
	
	if (AchSnd_Settings.Enable == "off") then
		print(" ")
		print(yel.."Achievement Sounds"..res)
		print(yel.."  This addon is "..red.."DISABLED"..res)
		print(yel.."  Type: "..blu.."/achsnd enable on"..res)
		print(yel.."  to enable."..res)
		return
	end
	
	if (cmd == "" ) then
		print(" ")
		print(" ")
		print(yel.."Achievement Sounds"..res)
		print(yel.."  Addon State:"..res)
		print(blu.."     Enable"..wht.." is "..statcolor(AchSnd_Settings.Enable)..res)
		print(yel.."  Triggers:"..res)
		print(blu.."     Guild"..wht.." achievements are "..statcolor(AchSnd_Settings.Guild)..res)
		print(blu.."     Party"..wht.." achievements are "..statcolor(AchSnd_Settings.Party)..res)
		print(blu.."     Near"..wht.." achievements are "..statcolor(AchSnd_Settings.Near)..res)
		print(yel.."  Outputs:")
		print(blu.."     Sound"..wht.." is "..statcolor(AchSnd_Settings.Sound)..res)
		print(blu.."     MSBT"..wht.." is  "..statcolor(AchSnd_Settings.MSBT)..res)
		print(blu.."     Popup"..wht.." is "..statcolor(AchSnd_Settings.Popup)..res)
		print(blu.."     Timeout"..wht.." is "..statcolor(AchSnd_Settings.Timeout)..res)
		print(blu.."     Random"..wht.." is "..statcolor(AchSnd_Settings.Random)..res)
		print(yel.."Available commands are listed above in "..blu.."BLUE."..res)
		print(" ")
		return
	end

	if (cmd == "guild") then
		if ((arg == "1") or (arg == "on")) then
			AchSnd_Settings.Guild = "on"
		elseif ((arg == "0") or (arg == "off")) then
			AchSnd_Settings.Guild = "off"
		end
		print(yel.."Achievement Sounds: Guild is now "..statcolor(AchSnd_Settings.Guild)..res)
		return
	end
	
	if (cmd == "party") then
		if ((arg == "1") or (arg == "on")) then
			AchSnd_Settings.Party = "on"
		elseif ((arg == "0") or (arg == "off")) then
			AchSnd_Settings.Party = "off"
		end
		print(yel.."Achievement Sounds: Party is now "..statcolor(AchSnd_Settings.Party)..res)
		return
	end

	if (cmd == "near") then
		if ((arg == "1") or (arg == "on")) then
			AchSnd_Settings.Near = "on"
		elseif ((arg == "0") or (arg == "off")) then
			AchSnd_Settings.Near = "off"
		end
		print(yel.."Achievement Sounds: Near is now "..statcolor(AchSnd_Settings.Near)..res)
		return
	end

	if (cmd == "sound") then
		if ((arg == "1") or (arg == "on")) then
			AchSnd_Settings.Sound = "on"
		elseif ((arg == "0") or (arg == "off")) then
				AchSnd_Settings.Sound = "off"
		end
		print(yel.."Achievement Sounds: Sound is now "..statcolor(AchSnd_Settings.Sound)..res)
		return
	end

	if (cmd == "msbt") then
		if ((arg == "1") or (arg == "on")) then
			AchSnd_Settings.MSBT = "on"
		elseif ((arg == "0") or (arg == "off")) then
			AchSnd_Settings.MSBT = "off"
		end
		print(yel.."Achievement Sounds: MSBT is now "..statcolor(AchSnd_Settings.MSBT)..res)
		return
	end

	if (cmd == "popup") then
		if ((arg == "1") or (arg == "on")) then
			AchSnd_Settings.Popup = "on"
		elseif ((arg == "0") or (arg == "off")) then
			AchSnd_Settings.Popup = "off"
		end
		print(yel.."Achievement Sounds: Popup is now "..statcolor(AchSnd_Settings.Popup)..res)
		return
	end
	
	if (cmd == "timeout") then
		if ((arg >= 0) and (arg <= 60)) then
			AchSnd_Settings.Timeout = arg
		end
		print(yel.."Achievement Sounds: Timeout is now "..statcolor(AchSnd_Settings.Timeout)..res)
		return
	end

	if (cmd == "random") then
		if ((arg == "1") or (arg == "on")) then
			AchSnd_Settings.Random = "on"
		elseif ((arg == "0") or (arg == "off")) then
			AchSnd_Settings.Random = "off"
		end
		print(yel.."Achievement Sounds: Random is now "..statcolor(AchSnd_Settings.Random)..res)
		return
	end

	print(" ")
	print(yel.."  Achievement Sounds"..res)
	print(red.."  Error: "..cmd.." is not a valid command"..res)
	print(yel.."  Type: "..blu.."/achsnd "..yel.."for the list of commands and addon status"..res)
	return
end


